package org.josast.app.amicalsat.cli;

import java.util.logging.Logger;

import org.josast.property.CONFIG;
import org.josast.property.ConfigObject;

public class AmicalsatCliConf extends ConfigObject {

	
	private Logger log = Logger.getLogger(getClass().getName());
	
	private String configurationFile = "defaultConfigFile.ini";
	private String smBinarieOutputFile=null;
	private boolean smGenerateBinarieFile = false;
	private String textualFile = null;
	private String configFileDefined  = "true";
	private String IPadress = "localhost";
	private int port = 8100;

	protected CONFIG ConfigFile = CONFIG.getInstance();
	
	
	public AmicalsatCliConf() {
		 
		initialise(configurationFile);
		
	}
	public AmicalsatCliConf(String configFilename) {
		configurationFile = configFilename;
		initialise(configurationFile);

	}
	
	private void  initialise(String configFilename )
	{
		// vérifie si la propriété est dans le fichier
		ConfigFile.setFileName(configurationFile);
		String  temp = ConfigFile.GetProperty("configFileDefined");
		
		if (temp == null) {
			// config file not initialised

			log.severe("properties file not initialised - a file is created with properties with defaults value");
			System.out.println("config file does not content required properties \n the file " + configFilename
					+ " has been set up with default properties to configure");
			Save();

		} else {
			
			initialiseFromProperties();
		}
	}
	
	private void initialiseFromProperties()
	{
		configFileDefined = ConfigFile.GetProperty("configFileDefined");
		IPadress = ConfigFile.GetProperty("IPadress");
		String portString = ConfigFile.GetProperty("port");
		port = Integer.parseInt(portString);
		smGenerateBinarieFile = Boolean.getBoolean(ConfigFile.GetProperty("smGenerateBinarieFile")); 
		smBinarieOutputFile =  ConfigFile.GetProperty("smBinarieOutputFile"); 
		
		textualFile = ConfigFile.GetProperty("textualFile");
		configurationFile = ConfigFile.GetProperty("configurationFile");
 		
	}	
	
	public void Save()
	{
		ConfigFile.SetProperty("configFileDefined", configFileDefined);
		ConfigFile.SetProperty("port", "" + port);
		ConfigFile.SetProperty("IPadress", "" + IPadress);
		ConfigFile.SetProperty("smBinarieOutputFile", "" + smBinarieOutputFile);
		ConfigFile.SetProperty("smGenerateBinarieFile", "" + smGenerateBinarieFile);
		ConfigFile.SetProperty("textualFile", "" + textualFile);
		ConfigFile.SetProperty("configurationFile", "" + configurationFile);
 
		
	}	
	
	public String getConfigurationFile() {
		return configurationFile;
	}
	public void setConfigurationFile(String configurationFile) {
		this.configurationFile = configurationFile;
	}
	public String getSmBinarieOutputFile() {
		return smBinarieOutputFile;
	}
	public void setSmBinarieOutputFile(String binariefile) {
		this.smBinarieOutputFile = binariefile;
		smGenerateBinarieFile = true;
	}
	public String getTextualFile() {
		return textualFile;
	}
	public void setTextualFile(String textualFile) {
		this.textualFile = textualFile;
	}
	
	
	
	
	

}
